//
// Created by martin on 9/17/18.
//

#ifndef LIB4NEURO_EXCEPTIONS_H
#define LIB4NEURO_EXCEPTIONS_H

#include <stdexcept>

/**
 * Class representing an error caused by an incorrect
 * input/output dimension specification
 */
class InvalidDimension : public std::runtime_error {
public:

    /**
     * Constructor with the general error message
     */
    InvalidDimension();

    /**
     * Constructor with specific error message
     * @param msg Specific error message
     */
    explicit InvalidDimension(std::string msg);
};

//TODO implement NotImplementedException according to C++17
/**
 *
 */
class NotImplementedException : public std::runtime_error {
public:

    /**
     *
     */
    NotImplementedException();

    /**
     *
     * @param msg
     */
    explicit NotImplementedException(std::string msg);
};

#endif //LIB4NEURO_EXCEPTIONS_H
